/** Update component component properties */
try{

    // Init component \see data in component html
    function onInitComponent(data){
        //console.log("[onInitComponent][" + data.source() + "][" + data + "]");
        onUpdate_mainframe(data);
        onGuiInit_vivaldigiovefree(data);
        return true;
    }
    // compones-mainframe.html callback
    function onGuiChangeGateway(sender,gateway,data) {
        //console.log("[onGuiChangeGateway][" + sender.source + "][" + gateway.getProtocol() + "][" + data + "]");
        return onUpdate_protocol(gateway.getProtocol(), data);
        return true;
    }
    /** On Update Component Function (Required)
     * Update component when some change has occured
     */
    function onUpdateComponent(data) {
        onUpdate_protocol(data.protocol(), data);

        var oComponent = data.node();
    	//Check
        if(! (oComponent instanceof Component) ){
            throw "oComponent is not a Component instance";
            return false;
        }

        //Set KNX write address
        $Elem = $componentProperties.find("[eve-manager-id='knx/write-address']");
        var aValue = oComponent.getParamVal("knx/write-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }

        //Set KNX feedback address
        $Elem = $componentProperties.find("[eve-manager-id='knx/feedback-address']");
        aValue = oComponent.getParamVal("knx/feedback-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }

        $Elem = $componentProperties.find("[eve-manager-id='knx/virtual-feedback']");
        $Elem.val(oComponent.getParamVal("knx/virtual-feedback"));

        $Elem = data.$properties().find("[eve-manager-id='knx/read-init']");
        $Elem.prop("checked", data.node().getParamVal("knx/read-init"));

        //Set KNX - functional block
        $Elem = $componentProperties.find("[eve-manager-id='knx/functional-block'] option");
        for(var i = 0; i < $Elem.length; ++i){
            var $currElem = $($Elem[i]);

            if($currElem.val() == oComponent.getParamVal("knx/functional-block")){
                $currElem.prop("selected",true);                                                    //Select format
                break;
            }
        }

        /** Vivaldi */
        {
            var json = blr.declarations.vivaldi.devices;
            $dropDown = $componentProperties.find("[eve-manager-id='vivaldi/device-pid']");
            var $none = $("<option value='none' dictionary='None'>"+ _D("None") +"</option>");
            $dropDown.append($none);

            //Parsing Vivaldi Devices
            for(var i=0; i<json.length; ++i){
                var $option = $("<option></option>");

                //Check if is for Combo
                if(json[i].componentsType.indexOf("tuner") != -1){
                    $option.text(json[i].itemCodes.toString() +" - "+ _D(json[i].label));
                    $option.attr("title", _D(json[i].label));
                    $option.val(json[i].pid);
                    $option.data("Vivaldi",json[i]);

                    //Append
                    $dropDown.append($option);
                }
            }

            //Disable if exist one choice
            $dropDown.prop("disabled",true);

            //Select currently PID
            var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("vivaldi/device-pid") +"']");
            var oVivaldiDevice = $selected.data("Vivaldi");

            //Select vivaldi device
            $selected.prop("selected",true);

            //Fill RC20 address
            $dropDown = $componentProperties.find("[eve-manager-id='vivaldi/device-id']");
            for(var i=0; i<oVivaldiDevice.idList.length; ++i){
                var $option = $("<option></option>");
                $option.text(oVivaldiDevice.idList[i]);
                $option.val(oVivaldiDevice.idList[i]);

                $dropDown.append($option);
            }

            var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("vivaldi/device-id") +"']");
            $selected.prop("selected",true);

            //Fill Function ID
            $dropDown = $componentProperties.find("[eve-manager-id='vivaldi/device-fid']");
            for(var i=0; i<oVivaldiDevice.fidList.length; ++i){
                if(oVivaldiDevice.fidList[i].fid == 9) {
                    var $option = $("<option></option>");
                    $option.text(oVivaldiDevice.fidList[i].label);
                    $option.val(oVivaldiDevice.fidList[i].fid);

                    $dropDown.append($option);
                }

            }

            var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("vivaldi/device-fid") +"']");
            $selected.prop("selected",true);

        }
        
        /** Aernova */
        
        //Set Aernova modes
        {
                var json = blr.declarations.aernova.functions;
                $dropDown = $componentProperties.find("[eve-manager-id='aernova/mode']");
                //Parsing Aernova modes
                for(var i=0; i<json.length; ++i){
                    var $option = $("<option></option>");
                   	if(json[i].fid == 6 || json[i].fid == 7 || json[i].fid == 8 || json[i].fid == 63 || json[i].fid == 71 || json[i].fid == 72) {
                        $option.text(_D(json[i].label));
                        $option.attr("title", _D(json[i].label));
                        $option.attr("dictionary", json[i].label);
                        $option.val(json[i].fid);
                        $option.data("Aernova",json[i]);
                        
                        //Append
                        $dropDown.append($option);
                    }
                }
                var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("aernova/mode") +"']");
				$selected.prop("selected",true);			
            }
		
        $Elem = $componentProperties.find("[eve-manager-id='aernova/address']");
        $Elem.val(oComponent.getParamVal("aernova/address"));    
        
        /** ODIC */
       	{
                var json = blr.declarations.odic.functions;
				//populate variable id dropdown
               	$dropDown = $componentProperties.find("[eve-manager-id='odic/variableid']");
                for(var i=0; i<json.variableId.length; ++i){
                	
                    var $option = $("<option></option>");	                   	
                    $option.text(_D(json.variableId[i].label));
                    $option.attr("title", _D(json.variableId[i].label));
                    $option.attr("dictionary", json.variableId[i].label);
                    $option.val(json.variableId[i].value);
                    
                    //Append
                    $dropDown.append($option);
                    
                }
	            $selected = $dropDown.find("[value='"+ oComponent.getParamVal("odic/variableid") +"']").prop("selected",true);
	            
	           	//populate integer dropdown
               	$dropDown = $componentProperties.find("[eve-manager-id='odic/type']");
                for(var i=0; i<json.type.length; ++i){
                	
                    var $option = $("<option></option>");	                   	
                    $option.text(_D(json.type[i].label));
                    $option.attr("title", _D(json.type[i].label));
                    $option.attr("dictionary", json.type[i].label);
                    $option.val(json.type[i].value);
                 	
                    //Append
                    $dropDown.append($option);
                    
                }
	            $selected = $dropDown.find("[value='"+ oComponent.getParamVal("odic/type") +"']").prop("selected",true);
	            
	           	var type = oComponent.getParamVal("odic/type");
	            if(type == 0) {
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/rmin']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyInt();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/rmax']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyInt();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/smin']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyInt();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/smax']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyInt();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/tmin']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyInt();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/tmax']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyInt();});
				}
				if(type == 1) {
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/rmin']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyFloat();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/rmax']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyFloat();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/smin']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyFloat();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/smax']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyFloat();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/tmin']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyFloat();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/tmax']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyFloat();});
				}        			
            }

        $Elem = $componentProperties.find("[eve-manager-id='odic/rmin']");
        $Elem.val(oComponent.getParamVal("odic/rmin"));
        
        $Elem = $componentProperties.find("[eve-manager-id='odic/rmax']");
        $Elem.val(oComponent.getParamVal("odic/rmax"));
        
        $Elem = $componentProperties.find("[eve-manager-id='odic/smin']");
        $Elem.val(oComponent.getParamVal("odic/smin"));
        
        $Elem = $componentProperties.find("[eve-manager-id='odic/smax']");
        $Elem.val(oComponent.getParamVal("odic/smax"));
        
        $Elem = $componentProperties.find("[eve-manager-id='odic/tmin']");
        $Elem.val(oComponent.getParamVal("odic/tmin"));
        
        $Elem = $componentProperties.find("[eve-manager-id='odic/tmax']");
        $Elem.val(oComponent.getParamVal("odic/tmax"));

        // Modbus
        {
                var json = blr.declarations.modbus.functions;
                //unit_id
                $dropDownRtuRead = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-unit-id']");
                $dropDownRtuWrite = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-unit-id']");
                $dropDownTcpRead = $componentProperties.find("[eve-manager-id='modbustcp/read-unit-id']");
                $dropDownTcpWrite = $componentProperties.find("[eve-manager-id='modbustcp/write-unit-id']");
                for(var i=0; i<json.unit_id.length; ++i){
                    var $option = $("<option></option>");
                    $option.text(_D(json.unit_id[i].label));
                    $option.attr("title", _D(json.unit_id[i].label));
                    $option.attr("dictionary", json.unit_id[i].label);
                    $option.val(json.unit_id[i].value);
                    //Append
                    $dropDownRtuRead.append($option);
                    $dropDownRtuWrite.append($option.clone());
                    $dropDownTcpRead.append($option.clone());
                    $dropDownTcpWrite.append($option.clone());
                }
                $selected = $dropDownRtuRead.find("[value='"+ oComponent.getParamVal("modbusrtutcp/read-unit-id") +"']").prop("selected",true);
                $selected = $dropDownRtuWrite.find("[value='"+ oComponent.getParamVal("modbusrtutcp/write-unit-id") +"']").prop("selected",true);
                $selected = $dropDownTcpRead.find("[value='"+ oComponent.getParamVal("modbustcp/read-unit-id") +"']").prop("selected",true);
                $selected = $dropDownTcpWrite.find("[value='"+ oComponent.getParamVal("modbustcp/write-unit-id") +"']").prop("selected",true);

                //switch_transform_type
                $dropDownRtuRead = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-type']");
                $dropDownRtuWrite = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-type']");
                $dropDownTcpRead = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-type']");
                $dropDownTcpWrite = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-type']");
                for(var i=0; i<json.switch_transform_type.length; ++i){
                    var $option = $("<option></option>");
                    $option.text(_D(json.switch_transform_type[i].label));
                    $option.attr("title", _D(json.switch_transform_type[i].label));
                    $option.attr("dictionary", json.switch_transform_type[i].label);
                    $option.val(json.switch_transform_type[i].value);
                    //Append
                    $dropDownRtuRead.append($option);
                    $dropDownRtuWrite.append($option.clone());
                    $dropDownTcpRead.append($option.clone());
                    $dropDownTcpWrite.append($option.clone());
                }
                $selected = $dropDownRtuRead.find("[value='"+ oComponent.getParamVal("modbusrtutcp/read-transform-type") +"']").prop("selected",true);
                $selected = $dropDownRtuWrite.find("[value='"+ oComponent.getParamVal("modbusrtutcp/write-transform-type") +"']").prop("selected",true);
                $selected = $dropDownTcpRead.find("[value='"+ oComponent.getParamVal("modbustcp/read-transform-type") +"']").prop("selected",true);
                $selected = $dropDownTcpWrite.find("[value='"+ oComponent.getParamVal("modbustcp/write-transform-type") +"']").prop("selected",true);


                //read_function_id
                $dropDownRtuRead = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-function-id']");
                $dropDownTcpRead = $componentProperties.find("[eve-manager-id='modbustcp/read-function-id']");
                for(var i=0; i<json.read_function_id.length; ++i){

                    var $option = $("<option></option>");
                    $option.text(_D(json.read_function_id[i].label));
                    $option.attr("title", _D(json.read_function_id[i].label));
                    $option.attr("dictionary", json.read_function_id[i].label);
                    $option.val(json.read_function_id[i].value);

                    //Append
                    $dropDownRtuRead.append($option);
                    $dropDownTcpRead.append($option.clone());
                }
                $selected = $dropDownRtuRead.find("[value='"+ oComponent.getParamVal("modbusrtutcp/read-function-id") +"']").prop("selected",true);
                $selected = $dropDownTcpRead.find("[value='"+ oComponent.getParamVal("modbustcp/read-function-id") +"']").prop("selected",true);


                //write_function_id
                $dropDownRtuWrite = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-function-id']");
                $dropDownTcpWrite = $componentProperties.find("[eve-manager-id='modbustcp/write-function-id']");
                for(var i=0; i<json.write_function_id.length; ++i){

                    var $option = $("<option></option>");
                    $option.text(_D(json.write_function_id[i].label));
                    $option.attr("title", _D(json.write_function_id[i].label));
                    $option.attr("dictionary", json.write_function_id[i].label);
                    $option.val(json.write_function_id[i].value);

                    //Append
                    $dropDownRtuWrite.append($option);
                    $dropDownTcpWrite.append($option.clone());
                }
                $selected = $dropDownRtuWrite.find("[value='"+ oComponent.getParamVal("modbusrtutcp/write-function-id") +"']").prop("selected",true);
                $selected = $dropDownTcpWrite.find("[value='"+ oComponent.getParamVal("modbustcp/write-function-id") +"']").prop("selected",true);

            }

        // ModbusTCP Read
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-unit-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-function-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-register-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-register-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-bit-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-bit-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-type']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-min']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-max']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-multiplier"));

        // ModbusTCP Write
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-unit-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-function-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-register-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-register-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-bit-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-bit-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-type']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-min']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-max']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-multiplier"));


        // ModbusRTUTCP Read
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-unit-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-function-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-register-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-register-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-bit-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-bit-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-type']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-min']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-max']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-multiplier"));

        // ModbusRTUTCP Write
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-unit-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-function-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-register-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-register-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-bit-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-bit-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-type']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-min']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-max']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-multiplier"));

    };

    function onUpdate_protocol(strProtocol, data) {
        switch (strProtocol) {
            case "vivaldigiovefree": {
                return onUpdate_vivaldigiovefree(data);
            } break;
            case "ghost": {
                return onUpdate_ghost(data);
            } break;
            default: {
                return onUpdate_default(data);
            }
        }
        return false;
    }
    function onUpdate_mainframe(data) {
        var $Elem = undefined;

        $("[eve-manager-id='UID']").text(data.node().UId);
        $("[eve-manager-id='type']").text(data.node().type);

        //Set name
        $Elem = data.$properties().find("[eve-manager-id='name']");
        $Elem.val(data.node().getParamVal("name"));

        //Set html name
        $Elem = $("#" + data.node().id + " .components-text");
        $Elem.text(data.node().getParamVal("name"));

        //Build gateways
        $Elem = data.$properties().find("[eve-manager-id='gateway']");
        $.publish("/view/gateways/refresh/dependencies");

        //Set gateways
        $Elem = data.$properties().find("[eve-manager-id='gateway'] option");
        data.$properties().find(".protocols").hide();												//Hide all protocols
        for (var i = 0; i < $Elem.length; ++i) {
            var $currElem = $($Elem[i]);
            var oNode = $currElem.data("eveManagerNode");
            var strProtocol;

            //Find gateway
            if (oNode === data.node().getParamVal("gateway")) {

                $currElem.prop("selected", true);													//Select gateway
                if (oNode == undefined) { break; }													//If none gateway is selected break for cicle

                var oGateway = oNode.getData();														//Get node data (gateway)

                strProtocol = oGateway.getProtocol();												//Get protocol id
                data.$properties().find("[eve-manager-protocol='" + strProtocol + "']").show();		//Show protocol view
                break;
            }
        }

        //Set enable history
        $Elem = data.$properties().find("[eve-manager-id='history']");
        $Elem.prop("checked", data.node().getParamVal("history"));

        //Set enable history
        $Elem = data.$properties().find("[eve-manager-id='savelastvalue']");
        $Elem.prop("checked", data.node().getParamVal("savelastvalue"));

        //Set enable history
        $Elem = data.$properties().find("[eve-manager-id='cache']");
        $Elem.prop("checked", data.node().getParamVal("cache"));



        refreshTags(data);


        //Set icon
        $Elem = data.$properties().find("[eve-manager-id='icons']");
        var aIcons = data.node().getParamVal("icons");

        $.publish("/view/components/" + data.node().id + "/refresh/parameter", [data.node(), "icons"]);

        //Set step
        $Elem = data.$properties().find("[eve-manager-id='step']");
        $Elem.val(data.node().getParamVal("step"));

        $Elem = data.$properties().find("[eve-manager-id='min']");
        $Elem.val(data.node().getParamVal("min"));

        $Elem = data.$properties().find("[eve-manager-id='max']");
        $Elem.val(data.node().getParamVal("max"));

        $Elem = data.$properties().find("[eve-manager-id='digits']");
        $Elem.val(data.node().getParamVal("digits"));

        $Elem = data.$properties().find("[eve-manager-id='suffix']");
        $Elem.val(data.node().getParamVal("suffix"));

        $Elem = data.$properties().find("[eve-manager-id='nolabel']");
        $Elem.prop("checked", data.node().getParamVal("nolabel"));


        return true;
    }
    function onGuiInit_vivaldigiovefree(data) {
        //console.log("onGuiInit_vivaldigiovefree");
        var jsonData = blr.declarations.vivaldi.giovefree.addresses;
        var $dropDown = data.$properties().find("[eve-manager-id='vivaldigiovefree/device-id']");
        for (var i = 0; i < jsonData.length; ++i) {
            var $option = $("<option></option>");
            $option.val(jsonData[i]);
            $option.text(jsonData[i]);
            $dropDown.append($option);
        }
        var $selected = $dropDown.find("[value='" + data.node().getParamVal("vivaldigiovefree/device-id") + "']");
        $selected.prop("selected", true);

        jsonData = blr.declarations.vivaldi.giovefree.tuner_fids;
        $dropDown = data.$properties().find("[eve-manager-id='vivaldigiovefree/device-fid']");
        for (var i = 0; i < jsonData.length; ++i) {
            var $option = $("<option></option>");
            $option.val(jsonData[i].fid);
            $option.text(_D(jsonData[i].label));
            $dropDown.append($option);
        }
        var $selected = $dropDown.find("[value='" + data.node().getParamVal("vivaldigiovefree/device-fid") + "']");
        $selected.prop("selected", true);
        return true;
    }
    function onGuiChange_vivaldigiovefree(sender) {
        //console.log("onGuiChange_vivaldigiovefree");
        var oNode = application.getSelectComponent().getData();
        var $this = $(sender);
        var strParam = $this.attr("eve-manager-id");
        var strValue = $this.find(":selected").val();
        //Save in Model
        $.publish("/model/components/" + oNode.id + "/update/parameter", [oNode, strParam, strValue]);
        $.publish("/view/components/" + oNode.id + "/refresh/parameter", [oNode, strParam]);
        return true;
    }
    function onUpdate_vivaldigiovefree(data) {
        //console.log("onUpdate_vivaldigiovefree");
        // We set the current value under onGuiInit, so the value is always synced
        return true;
    }
    function onUpdate_ghost(data) {
        var $Elem = data.$properties().find("[eve-manager-id='ghost/virtual-feedback']");
        $Elem.prop("checked", data.node().getParamVal("ghost/virtual-feedback"));

        $Elem = data.$properties().find("[eve-manager-id='ghost/updateonchange']");
        $Elem.prop("checked", data.node().getParamVal("ghost/updateonchange"));

        $Elem = data.$properties().find("[eve-manager-id='ghost/userdata']");
        $Elem.val(data.node().getParamVal("ghost/userdata"));

        return true;
    }
    function onUpdate_default(data) {
        return true;
    }
}
catch(err){
    console.error(err);
}
