/** iconEditor class (extends Window class)
 *
 * @class iconEditor
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 */
"use strict";

function logicEditor(oWindow){
	
	var self = this;

    var selectionState=0;


	/**
	 *
	 */
	var init = function(){
        console.log("%cWindow - iconEditor class initialization (extends Window class)","color:green");
        
        //Create jQuery UI dialog
        m_$element.dialog({
            height: "500",
            width: "700",
            autoOpen: false,
            modal: true,
            resizable: false,
            close: m_oWindow.hide,
            title: _D("Logic Editor"),
            create: function(e,ui){
                $(this).find(".actions button").button();
            }
        });
        
       //On Submit
        m_$element.on("submit","form",self._submit);
        
        //On reset
        m_$element.on("click",".actions [type='reset']",function(e){
            m_oWindow.hide();
        });


    };

    // REGION  variables
	/** Extended window object 
     * @type {Window}
     */
	var m_oWindow = oWindow;
	
	/** jQuery DOM element representing Window GUI
     * @type {jQuery}
     */
    var m_$element = oWindow;
    
    /** Edited icon
     * @type {object}
     */
    var m_oIcon;




	/** Show icon editor window
	 */
	this.show = function(oParam){
        var oNode = m_oWindow.getActiveNode();
	    var oData;
        if (oNode!=null) {
            oData = oNode.getData();
        }
        m_$element.dialog("open");


	};


    /** Hide icon editor window and closing operation
	 */
	this.hide = function(e,ui){
	    m_oIcon = undefined;
	    
	    //Show hidden elements
        m_$element.find(".actions [type='button']").show();
	    
	    //Close
	    m_$element.dialog("close");
	};
	
	/** Assign window HTML element 
     * @param $element jQuery element represent this window
     * @returns {Node}
     */
    this.assignWindow = function($element){
        m_$element = $element;
        
        //Initialization after graphic ready
        init();
    };
    

    
    /** Confirm changes
     * 
     */
    this._submit = function(e){
        var oNode = m_oWindow.getActiveNode();
        var oData;
        if (oNode!=null)
            oData = oNode.getData();
        

         if(oData instanceof Component)
         {
            var oComponent = oData;
            var ret="";
            var pos=0;
            while (pos<valueArrayYear.length)
            {
                ret+=valueArrayYear[pos];
                console.log(valueArrayYear);
                for (var i=0;i<31*12;i++)
                {
                    pos++;

                    ret=ret+valueArrayYear[pos];
                }
                pos++;

            }
            //Set model and view
            $.publish("/model/components/"+ oComponent.id +"/update/parameter",[oComponent,"gui/data",ret]);
             application.selectComponent(oNode);
         }



        //Call external window hide method
        m_oWindow.hide();
    };
}