/**
 * Created by blr on 25/10/15.
 */
"use strict";

var VERSION = "v.1.0.0";
var NAME = "Elmo Spa Wizard " + VERSION;
var $ = jQuery;


try {
    console.log("%cStart " + NAME, "color:DarkSlateBlue");
    create_gui();
    console.log("%cEnd " + NAME, "color:DarkSlateBlue");
} catch (err) {
    console.error(NAME + " error\n" + err);
    alert(NAME + " error\n" + err);
}


function create_gui() {
    var json = blr.declarations.elmo.fields;

    var wizard = $("<div id='eurothermsmartcomfot-wizard' title='" + NAME + "'></div>");
    wizard.append("</br><label>Name</label></br>");
    wizard.append("<input type='text' id='gtw-name' value='Elmo'/></br>");
    wizard.append("</br><label>Central Type</label></br>");
    var list = "<select type='text' id='gtw-central'>";
    for(var i=0; i<json.central.length; ++i){
        list += "<option value=" + i + ">" + _D(json.central[i].label) + "</option>";
    }
    list += "</select></br>";
    wizard.append(list);
    wizard.append("</br><label>Address</label></br>");
    wizard.append("<input type='text' id='gtw-address' value='192.168.1.250'/></br>");
    wizard.append("</br><label>Port</label></br>");
    wizard.append("<input type='text' id='gtw-port' value='10001' onkeypress='bigh.onlyPosInt();' /></br>");
    wizard.append("</br><label>Unit Address</label></br>");
    wizard.append("<input type='text' id='gtw-unitid' value='1' onkeypress='bigh.onlyPosInt();' /></br>");
    wizard.append("</br><input type='checkbox' id='gtw-authentication'>Authentication</input></br>");
    wizard.append("</br><label>User</label></br>");
    wizard.append("<input type='text' id='gtw-user' value='0' /></br>");
    wizard.append("</br><label>Password</label></br>");
    wizard.append("<input type='text' id='gtw-password' value='88888888' /></br>");

    $("body").append(wizard);

    wizard.dialog({
        modal: true,
        width: 350,
        close: function () {
            $(this).remove();
        },
        buttons: {
            "Create Componens...": function () {
                $(this).dialog("close");
                $(this).remove();

                blr.executionStack.show(NAME);
                main(
                    $(this).children("#gtw-name").val(),
                    $(this).children("#gtw-address").val(),
                    $(this).children("#gtw-port").val(),
                    $(this).children("#gtw-unitid").val(),
                    $(this).children("#gtw-authentication").prop( "checked" ),
                    $(this).children("#gtw-user").val(),
                    $(this).children("#gtw-password").val(),
                    $(this).children("#gtw-central").val()
                );
            },
            Cancel: function () {
                $(this).dialog("close");
                $(this).remove();
            }
        }
    });

    return wizard;
}

function main(name, ip, port, unitID, authentication, user, password,central) {
    try {
        var json = blr.declarations.elmo.fields.central[central];
        var oGateway = getGateway(name + " " + json.label, ip, port, unitID, authentication, user, password);
        var oMainGroup = getMainGroup(name + " " + json.label);

        var oStates = application.addComponent({
            type: "group",
            name: _D("States")
        }, oMainGroup);

        var oInfos = application.addComponent({type: "group", name: _D("Infos")}, oStates);
        blr.executionStack.push(
            function (in_args, out_args) {
                out_args = create_infos(
                    in_args.gateway,
                    in_args.group
                );
            },
            {
                gateway: oGateway,
                group: oInfos
            }
        );


        var oInputs = application.addComponent({type: "group", name: _D("Inputs")}, oStates);
        for (var i=0; i<json.inputs; ++i) {
            blr.executionStack.push(
                function (in_args, out_args) {
                    out_args = create_info_inputs(
                        in_args.gateway,
                        in_args.group,
                        in_args.id
                    );
                },
                {
                    gateway: oGateway,
                    group: oInputs,
                    id:i+1
                }
            );
        }

        var oInputsMemomry = application.addComponent({type: "group", name: _D("Inputs Memory")}, oStates);
        for (var i=0; i<json.inputs; ++i) {
            blr.executionStack.push(
                function (in_args, out_args) {
                    out_args = create_info_inputs_memory(
                        in_args.gateway,
                        in_args.group,
                        in_args.id
                    );
                },
                {
                    gateway: oGateway,
                    group: oInputsMemomry,
                    id:i+1
                }
            );
        }

        var oOutputs = application.addComponent({type: "group", name: _D("Outputs")}, oStates);
        for (var i=0; i<json.outputs; ++i) {
            blr.executionStack.push(
                function (in_args, out_args) {
                    out_args = create_info_outputs(
                        in_args.gateway,
                        in_args.group,
                        in_args.id
                    );
                },
                {
                    gateway: oGateway,
                    group: oOutputs,
                    id:i+1
                }
            );
        }

        var oGroups = application.addComponent({type: "group", name: _D("Groups")}, oStates);
        for (var i=0; i<json.groups; ++i) {
            blr.executionStack.push(
                function (in_args, out_args) {
                    out_args = create_info_groups(
                        in_args.gateway,
                        in_args.group,
                        in_args.id
                    );
                },
                {
                    gateway: oGateway,
                    group: oGroups,
                    id:i+1
                }
            );
        }

        var oGroupsMaxSecurity = application.addComponent({type: "group", name: _D("Groups Max Security")}, oStates);
        for (var i=0; i<json.groups; ++i) {
            blr.executionStack.push(
                function (in_args, out_args) {
                    out_args = create_info_groups_max_security(
                        in_args.gateway,
                        in_args.group,
                        in_args.id
                    );
                },
                {
                    gateway: oGateway,
                    group: oGroupsMaxSecurity,
                    id:i+1
                }
            );
        }

        var oCommands = application.addComponent({
            type: "group",
            name: _D("Commands")
        }, oMainGroup);

        blr.executionStack.push(
            function (in_args, out_args) {
                out_args = create_command_general(
                    in_args.gateway,
                    in_args.group
                );
            },
            {
                gateway: oGateway,
                group: oCommands
            }
        );

        var oGroupsCommand = application.addComponent({type: "group", name: _D("Groups")}, oCommands);
        for (var i=0; i<json.groups; ++i) {
            blr.executionStack.push(
                function (in_args, out_args) {
                    out_args = create_command_groups(
                        in_args.gateway,
                        in_args.group,
                        in_args.id
                    );
                },
                {
                    gateway: oGateway,
                    group: oGroupsCommand,
                    id:i+1
                }
            );
        }

        var oInputsCommand = application.addComponent({type: "group", name: _D("Inputs")}, oCommands);
        for (var i=0; i<json.groups; ++i) {
            blr.executionStack.push(
                function (in_args, out_args) {
                    out_args = create_command_inputs(
                        in_args.gateway,
                        in_args.group,
                        in_args.id
                    );
                },
                {
                    gateway: oGateway,
                    group: oInputsCommand,
                    id:i+1
                }
            );
        }

        var oOutputsCommand = application.addComponent({type: "group", name: _D("Outputs")}, oCommands);
        for (var i=0; i<json.groups; ++i) {
            blr.executionStack.push(
                function (in_args, out_args) {
                    out_args = create_command_outputs(
                        in_args.gateway,
                        in_args.group,
                        in_args.id
                    );
                },
                {
                    gateway: oGateway,
                    group: oOutputsCommand,
                    id:i+1
                }
            );
        }

        blr.executionStack.execute(50, true);
    } catch (err) {
        console.error(NAME + " error\n" + err);
        alert(NAME + " error\n" + err);
    }
}

function create_command_outputs(gateway,group,id) {
    var oItem = null;

    oItem = application.addComponent({
        type: "switch",
        gateway : gateway,
        name : _D("Output ") + id,
        "elmo/write-variable": 3,
        "elmo/write-id": id
    }, group);

    return oItem;
}


function create_command_inputs(gateway,group,id) {
    var oItem = null;

    oItem = application.addComponent({
        type: "switch",
        gateway : gateway,
        name : _D("Input ") + id,
        "elmo/write-variable": 2,
        "elmo/write-id": id
    }, group);

    return oItem;
}

function create_command_groups(gateway,group,id) {
    var oItem = null;

    oItem = application.addComponent({
        type: "lock",
        gateway : gateway,
        name : _D("Arm Group ") + id,
        password: "000000",
        "elmo/write-variable": 1,
        "elmo/write-id": id
    }, group);

    oItem = application.addComponent({
        type: "switch",
        gateway : gateway,
        name : _D("Arm Group ") + id,
        "elmo/write-variable": 1,
        "elmo/write-id": id
    }, group);


    return oItem;
}

function create_command_general(gateway,group) {
    var oItem = null;

    oItem = application.addComponent({
        type: "lock",
        gateway : gateway,
        name : _D("Arm All"),
        password: "000000",
        "elmo/write-variable": 0
    }, group);

    oItem = application.addComponent({
        type: "switch",
        gateway : gateway,
        name : _D("Arm All"),
        "elmo/write-variable": 0
    }, group);

    oItem = application.addComponent({
        type: "scenario",
        gateway : gateway,
        name : _D("Reset Events"),
        "elmo/write-variable": 0
    }, group);

    return oItem;
}


function create_info_groups_max_security(gateway,group,id) {
    var oItem = null;

    var index = i+1;
    oItem = application.addComponent({
        type: "info-color",
        gateway : gateway,
        name : _D("Group ") + id,
        "color-0":"#00C800",
        "color-1": "#C80000",
        "elmo/read-variable": 5,
        "elmo/read-id": id
    }, group);
    oItem = application.addComponent({
        type: "info-text",
        gateway : gateway,
        name : _D("Group ") + id,
        "text-0":_D("Disarmed"),
        "text-1": _D("Armed"),
        "color-0":"#00C800",
        "color-1": "#C80000",
        "elmo/read-variable": 5,
        "elmo/read-id": id
    }, group);


    return oItem;
}


function create_info_groups(gateway,group,id) {
    var oItem = null;

    oItem = application.addComponent({
        type: "info-color",
        gateway : gateway,
        name : _D("Group ") + id,
        "color-0":"#00C800",
        "color-1": "#C80000",
        "elmo/read-variable": 4,
        "elmo/read-id": id
    }, group);
    oItem = application.addComponent({
        type: "info-text",
        gateway : gateway,
        name : _D("Group ") + id,
        "text-0":_D("Disarmed"),
        "text-1": _D("Armed"),
        "color-0":"#00C800",
        "color-1": "#C80000",
        "elmo/read-variable": 4,
        "elmo/read-id": id
    }, group);

    oItem = application.addComponent({
        type: "info-color",
        gateway : gateway,
        name : _D("Insertable ") + id,
        "color-0":"#C80000",
        "color-1": "#00C800",
        "elmo/read-variable": 0,
        "elmo/read-id": id
    }, group);
    oItem = application.addComponent({
        type: "info-text",
        gateway : gateway,
        name : _D("Insertable ") + id,
        "text-0":_D("Not insertable"),
        "text-1": _D("Insertable"),
        "color-0":"#C80000",
        "color-1": "#00C800",
        "elmo/read-variable": 0,
        "elmo/read-id": id
    }, group);


    return oItem;
}


function create_info_outputs(gateway,group,id) {
    var oItem = null;
    oItem = application.addComponent({
        type: "info-color",
        gateway : gateway,
        name : _D("Output ") + id,
        "color-0":"#00C800",
        "color-1": "#C80000",
        "elmo/read-variable": 3,
        "elmo/read-id": id
    }, group);
    oItem = application.addComponent({
        type: "info-text",
        gateway : gateway,
        name : _D("Output ") + id,
        "text-0":_D("Deactive"),
        "text-1": _D("Active"),
        "color-0":"#00C800",
        "color-1": "#C80000",
        "elmo/read-variable": 3,
        "elmo/read-id": id
    }, group);


    return oItem;
}


function create_info_inputs(gateway,group,id) {
    var oItem = null;

    oItem = application.addComponent({
        type: "info-color",
        gateway : gateway,
        name : _D("Input ") + id,
        "color-0":"#00C800",
        "color-1": "#C80000",
        "elmo/read-variable": 1,
        "elmo/read-id": id
    }, group);
    oItem = application.addComponent({
        type: "info-text",
        gateway : gateway,
        name : _D("Input ") + id,
        "text-0":_D("Rest"),
        "text-1": _D("Alarm"),
        "color-0":"#00C800",
        "color-1": "#C80000",
        "elmo/read-variable": 1,
        "elmo/read-id": id
    }, group);

    return oItem;
}


function create_info_inputs_memory(gateway,group,id) {
    var oItem = null;

    oItem = application.addComponent({
        type: "info-color",
        gateway : gateway,
        name : _D("Memory ") + id,
        "color-0":"#00C800",
        "color-1": "#C80000",
        "elmo/read-variable": 2,
        "elmo/read-id": id
    }, group);
    oItem = application.addComponent({
        type: "info-text",
        gateway : gateway,
        name : _D("Memory ") + id,
        "text-0":_D("Rest"),
        "text-1": _D("Alarm"),
        "color-0":"#00C800",
        "color-1": "#C80000",
        "elmo/read-variable": 2,
        "elmo/read-id": id
    }, group);


    return oItem;
}


function create_infos(gateway,group){
    var oItem = null;
    ///////////////////////////////////////////
    // States
    ///////////////////////////////////////////
    oItem = application.addComponent({
        type: "info",
        gateway : gateway,
        name : _D("Connection State"),
        "elmo/read-variable": 0
    }, group);

    oItem = application.addComponent({
        type: "info",
        gateway : gateway,
        name : _D("Date Time"),
        "elmo/read-variable": 1
    }, group);

    oItem = application.addComponent({
        type: "info",
        gateway : gateway,
        name : _D("Version"),
        "elmo/read-variable": 2
    }, group);

    oItem = application.addComponent({
        type: "info",
        gateway : gateway,
        name : _D("Authentication Status"),
        "elmo/read-variable": 3
    }, group);

    oItem = application.addComponent({
        type: "info",
        gateway : gateway,
        name : _D("New Event"),
        "elmo/read-variable": 4
    }, group);

    oItem = application.addComponent({
        type: "info-color",
        gateway : gateway,
        name : _D("Power Network"),
        "color-0":"#00C800",
        "color-1": "#C80000",
        "elmo/read-variable": 6
    }, group);
    oItem = application.addComponent({
        type: "info-text",
        gateway : gateway,
        name : _D("Power Network"),
        "text-0":_D("OK"),
        "text-1": _D("Anomaly"),
        "color-0":"#00C800",
        "color-1": "#C80000",
        "elmo/read-variable": 6
    }, group);

    oItem = application.addComponent({
        type: "info-color",
        gateway : gateway,
        name : _D("Battery"),
        "color-0":"#00C800",
        "color-1": "#C80000",
        "elmo/read-variable": 7
    }, group);
    oItem = application.addComponent({
        type: "info-text",
        gateway : gateway,
        name : _D("Battery"),
        "text-0":_D("OK"),
        "text-1": _D("Anomaly"),
        "color-0":"#00C800",
        "color-1": "#C80000",
        "elmo/read-variable": 7
    }, group);

    oItem = application.addComponent({
        type: "info-color",
        gateway : gateway,
        name : _D("Tamper"),
        "color-0":"#00C800",
        "color-1": "#C80000",
        "elmo/read-variable": 8
    }, group);
    oItem = application.addComponent({
        type: "info-text",
        gateway : gateway,
        name : _D("Tamper"),
        "text-0":_D("OK"),
        "text-1": _D("Anomaly"),
        "color-0":"#00C800",
        "color-1": "#C80000",
        "elmo/read-variable": 8
    }, group);

    oItem = application.addComponent({
        type: "info-color",
        gateway : gateway,
        name : _D("Authentication Status"),
        "color-0":"#C80000",
        "color-1":"#00C800",
        "elmo/read-variable": 9
    }, group);
    oItem = application.addComponent({
        type: "info-text",
        gateway : gateway,
        name : _D("Authentication Status"),
        "text-0":_D("Error"),
        "text-1": _D("Authenticated"),
        "color-0": "#C80000",
        "color-1":"#00C800",
        "elmo/read-variable": 9
    }, group);

    return oItem;
}


function getGateway(name, address, port, unitID, authentication, user, password) {
    var oGateway = undefined;

    if (oGateway == undefined) {
        oGateway = application.addGateway({
            name: name,
            protocol: "elmo"
        });
    }
    oGateway.data.setName(name);
    oGateway.data.setParamVal("elmo/address", address);
    oGateway.data.setParamVal("elmo/port", port);
    oGateway.data.setParamVal("elmo/uid", unitID);
    oGateway.data.setParamVal("elmo/authentication", authentication);
    if (authentication) {
        oGateway.data.setParamVal("elmo/authentication_user", user);
        oGateway.data.setParamVal("elmo/authentication_password", password);
    }

    return oGateway;
}

function getMainGroup(name) {
    var oGroup = application.addComponent({
        type: "group",
        name: name
    });
    return oGroup;
}
